
/********************************************GaOm for SvgaShooter******************************************
***********author: Gadonarok******************************************************************************
/**********e-mail: gadonarok@freemail.hu******************************************************************
***********version: 1.02***********************************************************************************
***********last modified: 2002 10. 03.********************************************************************
**********************************************************************************************************
 *                                                                         *******************************
 *   This program is free software; you can redistribute it and/or modify  *******************************
 *   it under the terms of the GNU General Public License as published by  *******************************
 *   the Free Software Foundation; either version 2 of the License, or     *******************************
 *   (at your option) any later version.                                   *******************************
 *                                                                         *******************************
 *********************************************************************************************************
**********************************************************************************************************/
#include <stdlib.h>
#include <vga.h>
#include <vgagl.h>
#include <vgamouse.h>
#include <iostream.h>
#include <fstream.h>
#include <vector>

#include "gaomv1.02.h"
void Making(int = 0);
int OpenFile();

int main(void)
{
/*
       Basic SVGA modes:

       G640x480x256(10), G800x600x256(11), G1024x768x256(12), and
       G1280x1024x256(13)
*/
	/*a grafikus kperny belltsa*/
	vga_init();
	vga_setmode(10);
	gl_setcontextvga(10);

	vga_setmousesupport(1);

	gl_setfont(8, 8, gl_font8x8);
	gl_setwritemode(FONT_COMPRESSED + WRITEMODE_MASKED);
	gl_setfontcolors(0, vga_white());

	/*men kirajzolsa(egyszer)*/
	gl_write(0, 5, "GaOMv1.02 Copyright 2002 by Gad");
	gl_write(260, 150, "New Object");
	gl_write(257, 180, "Open Object");
	gl_write(280, 210, "Exit");

	/*az egr pozicionlsa* s kirajzolsa*/
	mouse_setposition(300, 240);
	gl_circle(300, 240, 3, 15);gl_setpixel(300, 240, 15);

	int X=300, Y=240;

	/*a men (?)futtatsa*/
	for(;;){
	if (mouse_update()){
		gl_circle(X, Y, 3, 0); gl_setpixel(X, Y, 0);

		/*az egr helynek megllaptsa*/
		X = mouse_getx(); Y = mouse_gety();

		/*megnzem, hogy menpont felett van-e az egr*/
		if ( (257 < mouse_getx()) && (343 > mouse_getx()) && (160 > mouse_gety()) && (147 < mouse_gety()))
			gl_setfontcolors(0, 4);
		gl_write(260, 150, "New Object");
		gl_setfontcolors(0, vga_white());

		if ( (254 < mouse_getx()) && (345 > mouse_getx()) && (190 > mouse_gety()) && (177 < mouse_gety()))
			gl_setfontcolors(0, 4);
		gl_write(257, 180, "Open Object");
		gl_setfontcolors(0, vga_white());

		if ( (277 < mouse_getx()) && (310 > mouse_getx()) && (220 > mouse_gety()) && (207 < mouse_gety()))
			gl_setfontcolors(0, 4);
		gl_write(280, 210, "Exit");
		gl_setfontcolors(0, vga_white());


		gl_write(0, 5, "GaOMv1.02 Copyright 2002 by Gad");
		gl_circle(mouse_getx(), mouse_gety(), 3, 15);gl_setpixel(mouse_getx(), mouse_gety(), 15);

		if (mouse_getbutton()){
			if ( (257 < mouse_getx()) && (343 > mouse_getx()) && (160 > mouse_gety()) && (147 < mouse_gety()))
				Making();
			if ( (254 < mouse_getx()) && (345 > mouse_getx()) && (190 > mouse_gety()) && (177 < mouse_gety()))
				Making(OpenFile());
			if ( (277 < X) && (310 > X) && (220 > Y) && (207 < Y) )
				{mouse_close(); vga_setmode(TEXT); return EXIT_SUCCESS;}
		}
	}
	if (vga_getkey()) { mouse_close(); vga_setmode(TEXT); return EXIT_SUCCESS;}
	}
}


void Making(int which){
	string name;

	/*az objektumok(a gombok) ltrehozsa*/
	Object* objects[16];
	Button Buttons[16];
	int i=0, i2=0;
	for (i=0; i<16; i++)
		objects[i] = &(Buttons[i]);


	/*az objektumok belltsa*/
	vector<string> szinek(16);
	szinek[0]="black";
	szinek[1]="blue";
	szinek[2]="green";
	szinek[3]="cyan";
	szinek[4]="red";
	szinek[5]="magenta";
	szinek[6]="brown";
	szinek[7]="grey";
	szinek[8]="darkgrey";
	szinek[9]="lightblue";
	szinek[10]="lightgreen";
	szinek[11]="lightcyan";
	szinek[12]="lightred";
	szinek[13]="lightmagenta";
	szinek[14]="yellow";
	szinek[15]="white";
	for (i=0; i<8; i++)
		objects[i]->SetValues(i*80, 1, (i+1)*80-1, 50, 1, szinek[i]);/*sznnek csak 8-nl kisebb-t adjunk meg, a ButtonPress() miatt(lsd a gaom.h-ban a kdot)*/
	for (i2=0; i<16; i++, i2++)
		objects[i]->SetValues(i2*80, 52, (i2+1)*80-1, 102, 1, szinek[i]);

	/*kperny trlse*/
	gl_clearscreen(0);

	fstream file;

	/*az egr pozicionlsa*/
	mouse_setposition(320, 240);

	/*az objectumok kirajzolsa(egyszer)*/
	for (i=0; i<16; i++)
	DrawButton(objects[i]->getX(), objects[i]->getY(), objects[i]->getX2(), objects[i]->getY2(), objects[i]->getW(), objects[i]->getH(), objects[i]->getTextX(), objects[i]->getTextY(), objects[i]->getColor(), objects[i]->getText());


	/* az object belltsa*/
	POO Parts[192];
	for (i=0; i<192; i++) Parts[i].Color = 0;
	file.open("objects", ios::in);
	for (i=0; i<which; i++)
		for (i2=0; i2<192; i2++)
			file >> Parts[i2].Color;
	file.close();

	/*a rajz kirajzolsa(egyszer)*/
	gl_drawrec(280, 288, 360, 348, 15, 0);
	for (i=0; i<16; i++)
	for (i2=0; i2<12; i2++)
		gl_drawrec(280+i*5, 288+i2*5, 280+(i+1)*5, 288+(i2+1)*5, 15, Parts[i*12+i2].Color);

	int X, Y, Xold, Yold, Color;

	for(;;)  {
	if (mouse_update()) {
	Xold=X;
	Yold=Y;

	/*az egr rgi helynek trlse(elszr az X s az Y = 0, vagyis ott trl)*/
	gl_circle(X, Y, 3, 0); gl_setpixel(X, Y, 0);

	/*nyom tisztts:)*/ /*innen*/
	for (i=0; i < 16; i++)
	if ((objects[i]->getX() < X) && (objects[i]->getX2() > X) && (objects[i]->getY() < Y) && (objects[i]->getY2() > Y))
{
	DrawButton(objects[i]->getX(), objects[i]->getY(), objects[i]->getX2(), objects[i]->getY2(), objects[i]->getW(), objects[i]->getH(), objects[i]->getTextX(), objects[i]->getTextY(), objects[i]->getColor(), objects[i]->getText());

	if (i!=0)
	DrawButton(objects[i-1]->getX(), objects[i-1]->getY(), objects[i-1]->getX2(), objects[i-1]->getY2(), objects[i-1]->getW(), objects[i-1]->getH(), objects[i-1]->getTextX(), objects[i-1]->getTextY(), objects[i-1]->getColor(), objects[i-1]->getText());

	if (i!=15)
	DrawButton(objects[i+1]->getX(), objects[i+1]->getY(), objects[i+1]->getX2(), objects[i+1]->getY2(), objects[i+1]->getW(), objects[i+1]->getH(), objects[i+1]->getTextX(), objects[i+1]->getTextY(), objects[i+1]->getColor(), objects[i+1]->getText());

	if (i<=7)
	DrawButton(objects[i+8]->getX(), objects[i+8]->getY(), objects[i+8]->getX2(), objects[i+8]->getY2(), objects[i+8]->getW(), objects[i+8]->getH(), objects[i+8]->getTextX(), objects[i+8]->getTextY(), objects[i+8]->getColor(), objects[i+8]->getText());

	if (i>=8)
	DrawButton(objects[i-8]->getX(), objects[i-8]->getY(), objects[i-8]->getX2(), objects[i-8]->getY2(), objects[i-8]->getW(), objects[i-8]->getH(), objects[i-8]->getTextX(), objects[i-8]->getTextY(), objects[i-8]->getColor(), objects[i-8]->getText());

	break;
}    /*idig trljtek ki, ha a nyomokat akarjtok megnzni*/

	/*az egr helynek megllaptsa*/
	X=mouse_getx(); Y=mouse_gety();

	if ((Y == 110) || (Y == 51) || (Y == 52))
	for (i=0; i<16; i++)
	DrawButton(objects[i]->getX(), objects[i]->getY(), objects[i]->getX2(), objects[i]->getY2(), objects[i]->getW(), objects[i]->getH(), objects[i]->getTextX(), objects[i]->getTextY(), objects[i]->getColor(), objects[i]->getText());



	/*80*60-s objektum kirajzolsa*//*mi lenne, ha 160*120-s lenne?(TODO)*/
	if ((272 < X) && (368 > X) && (280 < Y) && (356 > Y)){
	gl_drawrec(280, 288, 360, 348, 15, 0);
	for (i=0; i<16; i++)
	for (i2=0; i2<12; i2++)
		gl_drawrec(280+i*5, 288+i2*5, 280+(i+1)*5, 288+(i2+1)*5, 15, Parts[i*12+i2].Color);
	}

	/*az egr kirajzolsa*/
	gl_circle(X, Y, 3, 15);gl_setpixel(X, Y, 15);

	/*esemny kezels*/
	if (mouse_getbutton()){
	for (i=0; i < 16; i++)
		if ((objects[i]->getX() < X) && (objects[i]->getX2() > X) && (objects[i]->getY() < Y) && (objects[i]->getY2() > Y)){
			ButtonPress(objects[i]->getX(), objects[i]->getY(),  objects[i]->getX2(), objects[i]->getY2(), objects[i]->getTextX(), objects[i]->getTextY(), objects[i]->getColor(), objects[i]->getText());
			Color = i;
			break;
		}

			for (i=0; i<16; i++)
			for (i2=0; i2<12; i2++)
			if ((280+i*5 < X) && (288+i2*5 < Y) && (280+(i+1)*5 > X) && (288+(i2+1)*5 > Y)) Parts[i*12+i2].Color = Color;

}/*mouse_getbutton()*/
}/*mouse_update()*/

	/*kilps*/

	if (vga_getkey()) {
	gl_clearscreen(0);
	gl_write(270, 200, "What is it?");
	Object* objects[3];
	Button Buttons[3];
	int i=0, i2=0;

	vector<string> label(3);
	label[0]= "wall";
	label[1]= "floor";
	label[2]= "player";

	for (i=0; i<3; i++)
		objects[i] = &(Buttons[i]);
	for (i=0; i<3; i++)
		objects[i]->SetValues(210+i*80, 220, 290+i*80, 270, 1, label[i]);

	for (i=0; i<3; i++)
	DrawButton(objects[i]->getX(), objects[i]->getY(), objects[i]->getX2(), objects[i]->getY2(), objects[i]->getW(), objects[i]->getH(), objects[i]->getTextX(), objects[i]->getTextY(), objects[i]->getColor(), objects[i]->getText());

	int X, Y, OldX, OldY;

	for (;;){
	if (mouse_update()){

	gl_circle(X, Y, 3, 0);gl_setpixel(X, Y, 0);
	X= mouse_getx();Y= mouse_gety();

	if ( (X > (objects[0]->getX()-10)) && (X < (objects[2]->getX2()+10)) && (Y > (objects[0]->getY()-10)) && (Y < (objects[0]->getY2() + 10)))
	for (i=0; i<3; i++)
	DrawButton(objects[i]->getX(), objects[i]->getY(), objects[i]->getX2(), objects[i]->getY2(), objects[i]->getW(), objects[i]->getH(), objects[i]->getTextX(), objects[i]->getTextY(), objects[i]->getColor(), objects[i]->getText());

	gl_write(270, 200, "What is it??");

	if (mouse_getbutton())
	for (i=0; i<3; i++)
		if ((objects[i]->getX() < X) && (objects[i]->getY() < Y) && (objects[i]->getX2() > X) && (objects[i]->getY2() > Y)){
			ButtonPress(objects[i]->getX(), objects[i]->getY(), objects[i]->getX2(), objects[i]->getY2(), objects[i]->getTextX(), objects[i]->getTextY(), objects[i]->getColor(), objects[i]->getText());
			file.open("objects", ios::in | ios::out );
			POO wall[192], floor[192], player[192];
			int i3 = i;
			for (i=0; i<16; i++)
			for (i2=0; i2<12; i2++)
			file >> wall[i*12+i2].Color;

			for (i=0; i<16; i++)
			for (i2=0; i2<12; i2++)
			file >> floor[i*12+i2].Color;

			for (i=0; i<16; i++)
			for (i2=0; i2<12; i2++)
			file >> player[i*12+i2].Color;

			file.close();
			file.open("objects", ios::out | ios::trunc);

			switch (i3) {
			case 0:{
			for (i=0; i<16; i++)
			for (i2=0; i2<12; i2++)
			file << Parts[i*12+i2].Color << '\n';

			for (i=0; i<16; i++)
			for (i2=0; i2<12; i2++)
			file << floor[i*12+i2].Color << '\n';

			for (i=0; i<16; i++)
			for (i2=0; i2<12; i2++)
			file << player[i*12+i2].Color << '\n';
			break;}

			case 1:{
			for (i=0; i<16; i++)
			for (i2=0; i2<12; i2++)
			file << wall[i*12+i2].Color << '\n';

			for (i=0; i<16; i++)
			for (i2=0; i2<12; i2++)
			file << Parts[i*12+i2].Color << '\n';

			for (i=0; i<16; i++)
			for (i2=0; i2<12; i2++)
			file << player[i*12+i2].Color << '\n';
			break;}

			case 2:{

			for (i=0; i<16; i++)
			for (i2=0; i2<12; i2++)
			file << wall[i*12+i2].Color << '\n';

			for (i=0; i<16; i++)
			for (i2=0; i2<12; i2++)
			file << floor[i*12+i2].Color << '\n';

			for (i=0; i<16; i++)
			for (i2=0; i2<12; i2++)
			file << Parts[i*12+i2].Color << '\n';
			break;
			}

		}
	mouse_close(); vga_setmode(TEXT); exit(0);




			}/*if-*/
	}/*mouse_update-*/
	gl_circle(X, Y, 3, 15);gl_setpixel(X, Y, 15);

	if (vga_getkey()) {mouse_close(); vga_setmode(TEXT); exit(0);}
	}/*for-*/




	}
	}/*vga_getkey-*/

}/*Making-*/

/* az els a fal, aztn a padl, majd a jtkos*/
int OpenFile(){
	int i=0, i2=0;
	fstream file;
	file.open("objects", ios::in | ios::out);
	POO wall[192], floor[192], player[192];
	if (file.is_open()){
		for (i=0; i<16; i++)
		for (i2=0; i2<12; i2++)
		file >> wall[i*12+i2].Color;

		for (i=0; i<16; i++)
		for (i2=0; i2<12; i2++)
		file >> floor[i*12+i2].Color;

		for (i=0; i<16; i++)
		for (i2=0; i2<12; i2++)
		file >> player[i*12+i2].Color;
	}

	gl_clearscreen(0);
	int X=0, Y=0;

	/*kirajzolom a rajzot egyszer*/
	for (i=0; i<16; i++)
	for (i2=0; i2<12; i2++)
		gl_drawrec(160+i*5, 288+i2*5, 160+(i+1)*5, 288+(i2+1)*5, wall[i*12+i2].Color, wall[i*12+i2].Color);

	for (i=0; i<16; i++)
	for (i2=0; i2<12; i2++)
		gl_drawrec(280+i*5, 288+i2*5, 280+(i+1)*5, 288+(i2+1)*5, floor[i*12+i2].Color, floor[i*12+i2].Color);

	for (i=0; i<16; i++)
	for (i2=0; i2<12; i2++)
		gl_drawrec(400+i*5, 288+i2*5, 400+(i+1)*5, 288+(i2+1)*5, player[i*12+i2].Color, player[i*12+i2].Color);


	Object* objects[3];
	Button Buttons[3];
	for (i=0; i<3; i++)
		objects[i] = &(Buttons[i]);

	vector<string> label(3);
	label[0]= "wall";
	label[1]= "floor";
	label[2]= "player";

	for (i=0; i<3; i++)
		objects[i] = &(Buttons[i]);
	for (i=0; i<3; i++)
		objects[i]->SetValues(160+i*120, 220, 240+i*120, 270, 1, label[i]);


	for (i=0; i<3; i++)
	DrawButton(objects[i]->getX(), objects[i]->getY(), objects[i]->getX2(), objects[i]->getY2(), objects[i]->getW(), objects[i]->getH(), objects[i]->getTextX(), objects[i]->getTextY(), objects[i]->getColor(), objects[i]->getText());

	for (;;){
	if (mouse_update()){
	gl_circle(X, Y, 3, 0);gl_setpixel(X, Y, 0);
	X=mouse_getx();Y=mouse_gety();

	if ( (X > 150) && (Y > 278) && (X < 250) && (Y < 358))
//	gl_drawrec(280, 288, 360, 348, 15, 0);
	for (i=0; i<16; i++)
	for (i2=0; i2<12; i2++)
		gl_drawrec(160+i*5, 288+i2*5, 160+(i+1)*5, 288+(i2+1)*5, wall[i*12+i2].Color, wall[i*12+i2].Color);

	if ( (X > 270) && (Y > 278) && (X < 370) && (Y < 358))
	for (i=0; i<16; i++)
	for (i2=0; i2<12; i2++)
		gl_drawrec(280+i*5, 288+i2*5, 280+(i+1)*5, 288+(i2+1)*5, floor[i*12+i2].Color, floor[i*12+i2].Color);

	if ( (X > 390) && (Y > 278) && (X < 490) && (Y < 358))
	for (i=0; i<16; i++)
	for (i2=0; i2<12; i2++)
		gl_drawrec(400+i*5, 288+i2*5, 400+(i+1)*5, 288+(i2+1)*5, player[i*12+i2].Color, player[i*12+i2].Color);


	for (i=0; i<3; i++)
		if ((objects[i]->getX()-10 < X) && (objects[i]->getY()-10 < Y) && (objects[i]->getX2()+10 > X) && (objects[i]->getY2()+10 > Y))
			DrawButton(objects[i]->getX(), objects[i]->getY(), objects[i]->getX2(), objects[i]->getY2(), objects[i]->getW(), objects[i]->getH(), objects[i]->getTextX(), objects[i]->getTextY(), objects[i]->getColor(), objects[i]->getText());

	if (mouse_getbutton())
		for (i=0; i<3; i++)
			if ( (objects[i]->getX() < X) && (objects[i]->getY() < Y) && (objects[i]->getX2() > X) && (objects[i]->getY2() > Y))
				{
					ButtonPress(objects[i]->getX(), objects[i]->getY(), objects[i]->getX2(), objects[i]->getY2(), objects[i]->getTextX(), objects[i]->getTextY(), objects[i]->getColor(), objects[i]->getText());
					/*hogy a hats meglegyen:)*/
					return i+1;
				}/*a hossz if-*/
	gl_circle(X, Y, 3, 15);gl_setpixel(X, Y, 15);
	}/*mouse_update-*/
	if (vga_getkey()) {mouse_close(); vga_setmode(TEXT); exit(0);}
	}/*for-*/
	return 1;
}

