
/********************************************GaOm for SvgaShooter******************************************
***********author: Gadonarok******************************************************************************
/**********e-mail: gadonarok@freemail.hu******************************************************************
***********version: 1.02***********************************************************************************
***********last modified: 2002 10. 03.********************************************************************
**********************************************************************************************************
 *                                                                         *******************************
 *   This program is free software; you can redistribute it and/or modify  *******************************
 *   it under the terms of the GNU General Public License as published by  *******************************
 *   the Free Software Foundation; either version 2 of the License, or     *******************************
 *   (at your option) any later version.                                   *******************************
 *                                                                         *******************************
 *********************************************************************************************************
**********************************************************************************************************/


#include <string>


class Object{
	int X, Y, X2, Y2, TextX, TextY, Color;
	string Text;
	public:
		virtual void press();
		int getX(), getY(), getX2(), getY2(), getColor(), getW(), getH();
		char* getText();
		int getTextX(), getTextY();
		void SetValues(int LX, int LY, int LX2, int LY2, int C, string T);
};

class Button: public Object{
	public:
		void press();
};

void Object::press(){
	gl_write(0, 0, getText());
}


void Button::press(){
	gl_write(0, 0, getText());
}

char* Object::getText(){
	static char* c = new char[Text.length()+1];
	Text.copy(c, string::npos);
	c[Text.length()]= 0;
	return c;
}

int Object::getX(){
	return X;
}

int Object::getY(){
	return Y;
}

int Object::getX2(){
	return X2;
}

int Object::getY2(){
	return Y2;
}

int Object::getColor(){
	return Color;
}

int Object::getW(){
	return X2-X;
}

int Object::getH(){
	return Y2-Y;
}

void Object::SetValues(int LX, int LY, int LX2, int LY2, int C, string T){
	X=LX;
	Y=LY;
	X2=LX2;
	Y2=LY2;
	Color=C;
	Text=T;
	int dif = X2-X;;
	if (dif < 8*Text.length()){
		TextX= (8*Text.length())-dif;
		TextX= X-TextX/2+1;
	}
	else
		TextX= X+ (dif-8*Text.length())/2+1;
	TextY= Y+(Y2-Y)/2-2;
}

int Object::getTextX(){
	return TextX;
}

int Object::getTextY(){
	return TextY;
}

void gl_drawrec(int X, int Y, int X2, int Y2, int Color, int ColorIn);

void gl_drawrec(int X, int Y, int X2, int Y2, int Color, int ColorIn)
{
	gl_line(X, Y, X, Y2, Color);
	gl_line(X, Y, X2, Y, Color);
	gl_line(X2, Y2, X, Y2, Color);
	gl_line(X2, Y2, X2, Y, Color);
	gl_fillbox(X+1, Y+1, X2-X-1, Y2-Y-1, ColorIn);
}

class POO{
	public:
		int Color;
};

void ButtonPress(int, int, int, int, int, int, int, char*);

void ButtonPress(int X, int Y, int X2, int Y2, int TextX, int TextY, int Color, char* Text){
	int LightColor = Color+8;
	gl_line(X, Y, X2, Y, Color);
	gl_line(X, Y, X, Y2, 0);
	gl_line(X2, Y2, X2, Y, LightColor);
	gl_line(X2, Y2, X, Y2, LightColor);
	gl_write(TextX, TextY, Text);
}

void DrawButton(int, int, int, int, int, int, int, int, char*);

void DrawButton(int X, int Y, int X2, int Y2, int W, int H, int TextX, int TextY, int Color, char* Text){
	int LightColor = Color+8;
	gl_fillbox(X, Y, W, H, Color);
	gl_line(X, Y, X2, Y, LightColor);
	gl_line(X, Y, X, Y2, LightColor);
	gl_line(X2, Y2, X2, Y, Color);
	gl_line(X2, Y2, X, Y2, Color);
	gl_write(TextX, TextY, Text);
}
